// mememo.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "ini.h"
#include <fstream>

#define DEFAULT_FILENAME std::wstring(_T("\\My Documents\\mememo.txt"))
#define DEFAULT_ADDFROM std::wstring(_T("arg"))
#define DEFAULT_SHOWDIALOG std::wstring(_T("1"))
#define DEFAULT_MEMOFORMAT std::wstring(_T("[%DATE% %TIME%] %MEMO%\\n"))
#define DEFAULT_DATEFORMAT std::wstring(_T("yyyy/MM/dd"))
#define DEFAULT_TIMEFORMAT std::wstring(_T("HH:mm:ss"))

/**
 * dN`FbN
 *
 * @param hInstance CX^Xnh
 * @return dNĂȂTRUE
 */
#define MUTEX_GUID _T("{22A37F65-CF1F-4c23-9DB2-D489AACBB4B0}")
BOOL ExistInstance(HINSTANCE hInstance)
{
	CreateMutex(NULL, TRUE, MUTEX_GUID);
	return (GetLastError() == ERROR_ALREADY_EXISTS);
}

/**
 * ftHgݒINIt@C쐬B
 *
 * @param ini INIt@CIuWFNg
 */
void CreateDefaultIniFile(CIniFile &ini)
{
	std::wfstream stream(ini.GetIniFileName().c_str(), std::ios::out);
	if (stream.fail()) return;

	stream
		<< _T("[setting]") << std::endl
		<< _T("# ۑt@C") << std::endl
		<< _T("FileName=") << DEFAULT_FILENAME << std::endl
		<< std::endl
		<< _T("# ǋL") << std::endl
		<< _T("AddFrom=") << DEFAULT_ADDFROM << std::endl
		<< std::endl
		<< _T("# _CAO\邩ǂ") << std::endl
		<< _T("ShowDialog=") << DEFAULT_SHOWDIALOG << std::endl
		<< std::endl
		<< _T("# ̃tH[}bg") << std::endl
		<< _T("MemoFormat=") << DEFAULT_MEMOFORMAT << std::endl
		<< std::endl
		<< _T("# t̃tH[}bg") << std::endl
		<< _T("DateFormat=") << DEFAULT_DATEFORMAT << std::endl
		<< std::endl
		<< _T("# Ԃ̃tH[}bg") << std::endl
		<< _T("TimeFormat=") << DEFAULT_TIMEFORMAT << std::endl
	;
	stream.close();

	ini.Load();
}

/**
 * t̃tH[}bgs
 *
 * @param systemTime VXet
 * @param dateFormat t̃tH[}bg
 * @return t
 */
std::wstring FormatDate(SYSTEMTIME systemTime, std::wstring &dateFormat)
{
	wchar_t buff[128];
	::GetDateFormat(LOCALE_USER_DEFAULT, 0, &systemTime, dateFormat.c_str(), buff, 127);
	return buff;
}

/**
 * Ԃ̃tH[}bgs
 *
 * @param systemTime VXet
 * @param timeFormat Ԃ̃tH[}bg
 * @return ԕ
 */
std::wstring FormatTime(SYSTEMTIME systemTime, std::wstring &timeFormat)
{
	wchar_t buff[128];
	::GetTimeFormat(LOCALE_USER_DEFAULT, 0, &systemTime, timeFormat.c_str(), buff, 127);
	return buff;
}

/**
 * ̒usB
 *
 * @param 
 */
std::wstring &replace(std::wstring &str, const std::wstring &from, const std::wstring &to)
{
	std::wstring::size_type pos, now = 0;
	while ((pos = str.find(from, now)) != std::wstring::npos) {
		str.replace(pos, from.size(), to);
		now = pos + to.size();
	}
	return str;
}

/**
 * 쐬B
 *
 * @param memo e̕
 * @param ini INIt@CIuWFNg
 * @return o͂郁
 */
std::wstring CreateMemoString(std::wstring memo, CIniFile &ini)
{
	SYSTEMTIME st;
	GetLocalTime(&st);
	std::wstring result = ini.GetValue(_T("setting"), _T("MemoFormat"), DEFAULT_MEMOFORMAT);
	replace(result, _T("%DATE%"), FormatDate(st, ini.GetValue(_T("setting"), _T("DateFormat"), DEFAULT_DATEFORMAT)));
	replace(result, _T("%TIME%"), FormatTime(st, ini.GetValue(_T("setting"), _T("TimeFormat"), DEFAULT_TIMEFORMAT)));
	replace(result, _T("\\n"), _T("\r\n"));
	replace(result, _T("%MEMO%"), memo);
	return result;
}

/**
 * t@CɒǋL
 *
 * @param fileName t@C
 * @param memo e
 * @return ǋLɐTRUE
 */
BOOL AppendFile(const std::wstring &fileName, const std::wstring &memo)
{
	std::wfstream stream(fileName.c_str(), std::ios::app);
	if (stream.fail()) return FALSE;
	stream << memo;
	stream.close();
	return TRUE;
}

/**
 * Nbv{[h擾
 */
BOOL GetClipboard(std::wstring &data)
{
	BOOL result = FALSE;
	HANDLE hText;
	WCHAR *lpGetData = NULL;

	if (OpenClipboard(NULL)) {
		hText = GetClipboardData(CF_UNICODETEXT);
		if (hText) {
			// eLXgf[^擾
			lpGetData = (WCHAR *) GlobalLock(hText);
			data = lpGetData;
			GlobalUnlock(hText);

			result = TRUE;
		}
		CloseClipboard();
	}
	
	return result;
}

/**
 * Nbv{[hɒǋL
 *
 * @param memo e
 * @return ǋLɐTRUE
 */
BOOL AppendClipboard(std::wstring &memo)
{
	BOOL result = FALSE;
	HANDLE hText;

	//f[^쐬
	std::wstring clip;
	GetClipboard(clip);
	clip.append(memo);

	int size = sizeof(WCHAR) * clip.size();
	hText = GlobalAlloc(GMEM_DDESHARE | GMEM_MOVEABLE, size);
	if (hText) {
		//f[^ݒ
		WCHAR *data = (WCHAR *) GlobalLock(hText);
		wcscpy_s(data, size, clip.c_str());
		GlobalUnlock(hText);

		//Nbv{[hɐݒ
		if (OpenClipboard(NULL)) {
			EmptyClipboard();
			HANDLE x = SetClipboardData(CF_UNICODETEXT, hText);
			if (x) {
				result = TRUE;
			}
			CloseClipboard();
		}
	}

	return result;
}

int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{

	// dN`FbN
	if (ExistInstance(hInstance)) return 0;

	// init@C[h
	CIniFile ini(hInstance);
	if (ini.Fail()) {
		CreateDefaultIniFile(ini);
	}

	std::wstring memo;
	if (ini.GetValue(_T("setting"), _T("AddFrom"), DEFAULT_ADDFROM) == _T("clipboard")) {
		GetClipboard(memo);
	} else {                
		memo = lpCmdLine;
	}

	// 쐬
	memo = CreateMemoString(memo, ini);

	// t@C擾
	std::wstring &FileName = ini.GetValue(_T("setting"), _T("FileName"), DEFAULT_FILENAME);

	BOOL result = FALSE;
	std::wstring msg;
	if (FileName == _T("clipboard")) {
		// Nbv{[hɒǋL
		result = AppendClipboard(memo);
		msg = _T("Nbv{[h");
	} else {
		// ɒǋL
		result = AppendFile(FileName, memo);
		msg = _T("t@C");
	}

	if (result) {
		// bZ[W\
		if (ini.GetValue(_T("setting"), _T("ShowDialog"), DEFAULT_SHOWDIALOG) == _T("1")) {
			MessageBox(GetForegroundWindow(), (msg + _T("ۑ܂B")).c_str(), _T("mF"), MB_OK);
		}
	} else {
		// sbZ[W\
		MessageBox(GetForegroundWindow(), (msg + _T("ۑł܂łB")).c_str(), _T("mF"), MB_OK);
	}

	return 0;
}
